(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/add/operator/toPromise'), require('@harmowatch/redux-decorators'), require('rxjs/AsyncSubject'), require('rxjs/Observable'), require('rxjs/add/operator/map'), require('rxjs/ReplaySubject'), require('rxjs/add/operator/distinctUntilChanged'), require('rxjs/add/operator/takeWhile'), require('rxjs/BehaviorSubject'), require('redux'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'rxjs/add/operator/toPromise', '@harmowatch/redux-decorators', 'rxjs/AsyncSubject', 'rxjs/Observable', 'rxjs/add/operator/map', 'rxjs/ReplaySubject', 'rxjs/add/operator/distinctUntilChanged', 'rxjs/add/operator/takeWhile', 'rxjs/BehaviorSubject', 'redux', '@angular/common'], factory) :
	(factory((global.harmowatch = global.harmowatch || {}, global.harmowatch['ngx-redux-core'] = {}),global.ng.core,global.Rx.Observable.prototype,global.reduxDecorators,global.Rx,global.Rx,global.Rx.Observable.prototype,global.Rx,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx,global.redux,global.ng.common));
}(this, (function (exports,core,toPromise,reduxDecorators,AsyncSubject,Observable,map,ReplaySubject,distinctUntilChanged,takeWhile,BehaviorSubject,redux,common) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = Object.setPrototypeOf ||
    ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
    function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}


function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxStateDefinitionToken = /** @class */ (function (_super) {
    __extends(ReduxStateDefinitionToken, _super);
    function ReduxStateDefinitionToken() {
        return _super.call(this, 'ReduxStateDefinitionToken') || this;
    }
    return ReduxStateDefinitionToken;
}(core.InjectionToken));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxStore = /** @class */ (function (_super) {
    __extends(ReduxStore, _super);
    function ReduxStore() {
        return _super.call(this, 'ReduxStore') || this;
    }
    return ReduxStore;
}(core.InjectionToken));
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
var ReduxRegistry = /** @class */ (function () {
    /**
     * @param {?=} store
     */
    function ReduxRegistry(store) {
        if (store === void 0) { store = null; }
        ReduxRegistry.reset();
        ReduxRegistry.registerStore(store);
    }
    /**
     * @return {?}
     */
    ReduxRegistry.reset = function () {
        ReduxRegistry._store = new AsyncSubject.AsyncSubject();
    };
    /**
     * @param {?} store
     * @return {?}
     */
    ReduxRegistry.registerStore = function (store) {
        ReduxRegistry.reset();
        ReduxRegistry._store.next(store);
        ReduxRegistry._store.complete();
        reduxDecorators.ReduxActionDispatcher.dispatchedActions.subscribe(function (action) {
            var /** @type {?} */ reduxAction = {
                type: action.type,
                payload: action.payload,
            };
            store.dispatch(reduxAction);
            if (action.onDispatchSuccess) {
                action.onDispatchSuccess();
            }
        });
    };
    /**
     * @param {?} state
     * @return {?}
     */
    ReduxRegistry.registerState = function (state) {
        ReduxRegistry.getStore().then(function (store) {
            var /** @type {?} */ stateConfig = reduxDecorators.ReduxStateDecorator.get(state.constructor);
            var /** @type {?} */ initialState = state.getInitialState();
            Promise
                .resolve(initialState instanceof Observable.Observable ? initialState.toPromise() : initialState)
                .then(function (initialValue) {
                store.dispatch({
                    payload: {
                        initialValue: initialValue,
                        name: stateConfig.name,
                    },
                    type: ReduxRegistry.ACTION_REGISTER_STATE,
                });
            });
        });
    };
    /**
     * @return {?}
     */
    ReduxRegistry.getStore = function () {
        return new Promise(ReduxRegistry._store.subscribe.bind(ReduxRegistry._store));
    };
    return ReduxRegistry;
}());
ReduxRegistry.ACTION_REGISTER_STATE = "@harmowatch/ngx-redux-core/registerState";
ReduxRegistry._store = new AsyncSubject.AsyncSubject();
ReduxRegistry.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ReduxRegistry.ctorParameters = function () { return [
    { type: undefined, decorators: [{ type: core.Inject, args: [ReduxStore,] },] },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxSelector = /** @class */ (function (_super) {
    __extends(ReduxSelector, _super);
    /**
     * @param {?=} selector
     * @param {?=} stateProvider
     */
    function ReduxSelector(selector, stateProvider) {
        if (selector === void 0) { selector = '/'; }
        var _this = this;
        if (!selector.startsWith(ReduxSelector.DELIMITER) && !stateProvider) {
            throw new Error('You need to provide a state provider, if you use relative selectors');
        }
        _this = _super.call(this, 1) || this;
        ReduxRegistry.getStore().then(function (store) {
            var /** @type {?} */ next = function () {
                _this.next(ReduxSelector.getValueByState(store.getState(), selector, stateProvider));
            };
            store.subscribe(function () { return next(); });
            next(); // we need to trigger a initial value, otherwise we've to wait until the first state change
        });
        return _this;
    }
    /**
     * @param {?} selector
     * @param {?=} stateProvider
     * @return {?}
     */
    ReduxSelector.normalize = function (selector, stateProvider) {
        if (!selector.startsWith(ReduxSelector.DELIMITER)) {
            var /** @type {?} */ stateName = reduxDecorators.ReduxStateDecorator.get(stateProvider).name;
            return "" + ReduxSelector.DELIMITER + stateName + ReduxSelector.DELIMITER + selector;
        }
        return selector;
    };
    /**
     * @template S
     * @param {?} state
     * @param {?} selector
     * @param {?=} stateProvider
     * @return {?}
     */
    ReduxSelector.getValueByState = function (state, selector, stateProvider) {
        /* save the return value in a constant to prevent
             * "Metadata collected contains an error that will be reported at runtime: Lambda not supported."
             * error
             */
        var /** @type {?} */ value = ReduxSelector.normalize(selector, stateProvider).split(ReduxSelector.DELIMITER)
            .filter(function (propertyKey) { return propertyKey !== ''; })
            .reduce(function (previousValue, propertyKey) {
            if (!previousValue || !previousValue.hasOwnProperty(propertyKey)) {
                return null;
            }
            return previousValue[propertyKey];
        }, /** @type {?} */ (state));
        return value;
    };
    return ReduxSelector;
}(ReplaySubject.ReplaySubject));
ReduxSelector.DELIMITER = '/';
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
var ReduxStateProvider = /** @class */ (function () {
    /**
     * @param {?=} stateDefs
     */
    function ReduxStateProvider(stateDefs) {
        if (stateDefs === void 0) { stateDefs = []; }
        var _this = this;
        this.selectorCache = {};
        var _a = (reduxDecorators.ReduxStateDecorator.get(this.constructor) || {}).name, name = _a === void 0 ? null : _a;
        if (!name) {
            throw new Error('Unable to resolve state name! Make sure you\'ve decorated the provider by "@ReduxState"!');
        }
        this.name = reduxDecorators.ReduxStateDecorator.get(this.constructor).name;
        this.stateDef = stateDefs.find(function (def) { return reduxDecorators.ReduxStateDecorator.get(def.provider).name === name; });
        if (!this.stateDef) {
            throw new Error('Unable to resolve state definition! Make sure you\'ve registered the provider to ReduxModule!');
        }
        this.reducerMethodsByType = (this.stateDef.reducers || [])
            .map(function (clazz) { return _this.getReducerMethods(new clazz()); })
            .reduce(function (all, curr) { return [].concat(curr, all); }, []) // [].concat keeps the order, all.concat(curr) destroys the order
            .reduce(function (methodsByType, reducer) {
            var /** @type {?} */ type = reduxDecorators.ReduxActionDispatcher.getType(reducer.type);
            return Object.assign({}, methodsByType, (_a = {}, _a[type] = [reducer.method].concat(methodsByType[type] || []), _a));
            var _a;
        }, {});
        ReduxStateProvider.instancesByName[this.name] = this;
    }
    /**
     * @return {?}
     */
    ReduxStateProvider.prototype.getInitialState = function () {
        throw new Error('Method "getInitialState" not implemented.');
    };
    /**
     * @template T
     * @param {?=} selector
     * @return {?}
     */
    ReduxStateProvider.prototype.select = function (selector) {
        if (selector === void 0) { selector = ''; }
        var /** @type {?} */ stateType = (this.constructor);
        selector = ReduxSelector.normalize(selector, stateType);
        if (!this.selectorCache[selector]) {
            this.selectorCache[selector] = new ReduxSelector(selector, stateType).distinctUntilChanged();
        }
        return /** @type {?} */ (this.selectorCache[selector]);
    };
    /**
     * @return {?}
     */
    ReduxStateProvider.prototype.getState = function () {
        var _this = this;
        return ReduxRegistry.getStore().then(function (store) {
            return ReduxSelector.getValueByState(store.getState(), '/' + _this.name);
        });
    };
    /**
     * @template P
     * @param {?} state
     * @param {?} action
     * @return {?}
     */
    ReduxStateProvider.prototype.reduce = function (state, action) {
        var /** @type {?} */ reducerMethods = this.reducerMethodsByType[action.type] || [];
        return reducerMethods.reduce(function (stateToReduce, method) { return method(stateToReduce, action); }, state);
    };
    /**
     * @param {?} reducerClassInstance
     * @return {?}
     */
    ReduxStateProvider.prototype.getReducerMethods = function (reducerClassInstance) {
        return Object.values(Object.getPrototypeOf(reducerClassInstance))
            .map(function (method) {
            return {
                method: ((method)).bind(reducerClassInstance),
                type: reduxDecorators.ReduxReducerDecorator.get(method),
            };
        })
            .filter(function (type) { return type != null; })
            .reduce(function (all, curr) { return all.concat([].concat(curr.type).map(function (type) { return (Object.assign({}, curr, { type: type })); })); }, []);
    };
    return ReduxStateProvider;
}());
ReduxStateProvider.instancesByName = {};
/** @nocollapse */
ReduxStateProvider.ctorParameters = function () { return [
    { type: Array, decorators: [{ type: core.Inject, args: [ReduxStateDefinitionToken,] },] },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @template S
 * @param {?} expression
 * @param {?=} context
 * @return {?}
 */
function ReduxSelect(expression, context) {
    return function (target, propertyKey) {
        var /** @type {?} */ stateName = reduxDecorators.ReduxStateDecorator.get(context).name;
        Object.defineProperty(target, propertyKey, {
            get: function () { return ReduxStateProvider.instancesByName[stateName].select(expression); }
        });
    };
}
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxReducerProvider = /** @class */ (function () {
    function ReduxReducerProvider() {
        this.stateProviders = {};
    }
    Object.defineProperty(ReduxReducerProvider.prototype, "rootReducer", {
        /**
         * @return {?}
         */
        get: function () {
            return this.reduce.bind(this);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} provider
     * @return {?}
     */
    ReduxReducerProvider.prototype.addStateProvider = function (provider) {
        if (!this.stateProviders[provider.name]) {
            ReduxRegistry.registerState(provider);
            this.stateProviders[provider.name] = provider;
        }
        else {
            throw new Error("State \"" + provider.name + "\" is registered twice! Make sure your state name is unique!");
        }
    };
    /**
     * @param {?} rootState
     * @param {?} action
     * @return {?}
     */
    ReduxReducerProvider.prototype.reduce = function (rootState, action) {
        if (action.type === ReduxRegistry.ACTION_REGISTER_STATE) {
            var /** @type {?} */ regAction = (((action)));
            return Object.assign({}, rootState, (_a = {}, _a[regAction.payload.name] = regAction.payload.initialValue, _a));
        }
        return Object.values(this.stateProviders).reduce(function (stateToReduce, provider) {
            return Object.assign({}, stateToReduce, (_a = {}, _a[provider.name] = provider.reduce(stateToReduce[provider.name], action), _a));
            var _a;
        }, rootState);
        var _a;
    };
    return ReduxReducerProvider;
}());
ReduxReducerProvider.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ReduxReducerProvider.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxSelectPipe = /** @class */ (function () {
    /**
     * @param {?=} stateDefs
     * @param {?=} injector
     */
    function ReduxSelectPipe(stateDefs, injector) {
        if (stateDefs === void 0) { stateDefs = []; }
        this.provider = /** @type {?} */ (injector.get(stateDefs[0].provider));
    }
    /**
     * @param {?} selector
     * @return {?}
     */
    ReduxSelectPipe.prototype.transform = function (selector) {
        return this.provider.select(selector);
    };
    return ReduxSelectPipe;
}());
ReduxSelectPipe.decorators = [
    { type: core.Pipe, args: [{ name: 'reduxSelect' },] },
];
/** @nocollapse */
ReduxSelectPipe.ctorParameters = function () { return [
    { type: Array, decorators: [{ type: core.Inject, args: [ReduxStateDefinitionToken,] },] },
    { type: core.Injector, },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxTestingStore = /** @class */ (function () {
    function ReduxTestingStore() {
        this.state = new BehaviorSubject.BehaviorSubject(null);
    }
    /**
     * @return {?}
     */
    ReduxTestingStore.factory = function () {
        return new ReduxTestingStore();
    };
    /**
     * @template S
     * @param {?} state
     * @param {?} value
     * @return {?}
     */
    ReduxTestingStore.prototype.setState = function (state, value) {
        var _this = this;
        var name = reduxDecorators.ReduxStateDecorator.get(state).name;
        var /** @type {?} */ nextState = Object.assign({}, this.state.getValue(), (_a = {}, _a[name] = value, _a));
        this.state.next(nextState);
        return this.state
            .takeWhile(function (currentState) { return currentState !== nextState; })
            .toPromise().then(function () { return _this.state.getValue(); });
        var _a;
    };
    /**
     * @return {?}
     */
    ReduxTestingStore.prototype.getState = function () {
        return this.state.getValue();
    };
    /**
     * @param {?} listener
     * @return {?}
     */
    ReduxTestingStore.prototype.subscribe = function (listener) {
        return this.state.subscribe.call(this.state, listener);
    };
    /**
     * @return {?}
     */
    ReduxTestingStore.prototype.replaceReducer = function () {
    };
    /**
     * @template T
     * @param {?} action
     * @return {?}
     */
    ReduxTestingStore.prototype.dispatch = function (action) {
        return action;
    };
    return ReduxTestingStore;
}());
ReduxTestingStore.decorators = [
    { type: core.Injectable },
];
/** @nocollapse */
ReduxTestingStore.ctorParameters = function () { return []; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
exports.TestingStateProvider = TestingStateProvider_1 = /** @class */ (function (_super) {
    __extends(TestingStateProvider, _super);
    function TestingStateProvider() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @return {?}
     */
    TestingStateProvider.prototype.getInitialState = function () {
        return TestingStateProvider_1.INITIAL_STATE;
    };
    return TestingStateProvider;
}(ReduxStateProvider));
exports.TestingStateProvider.NAME = 'testing-7c66b613-20bd-4d35-8611-5181ca4a0b72';
exports.TestingStateProvider.INITIAL_STATE = {
    todo: {
        isFetching: false,
        items: ['Item 1', 'Item 2'],
    },
};
exports.TestingStateProvider = TestingStateProvider_1 = __decorate([
    reduxDecorators.ReduxStateDecoratorForClass({ name: TestingStateProvider_1.NAME })
], exports.TestingStateProvider);
var TestingStateProvider_1;
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var ReduxModule = /** @class */ (function () {
    /**
     * @param {?} injector
     * @param {?} reducerProvider
     * @param {?=} stateDefs
     */
    function ReduxModule(injector, reducerProvider, stateDefs) {
        if (stateDefs === void 0) { stateDefs = []; }
        injector.get(ReduxRegistry); // just make sure the provider is instantiated
        if (Array.isArray(stateDefs)) {
            stateDefs
                .filter(function (def) { return def && def.provider; })
                .map(function (def) { return injector.get(def.provider); })
                .forEach(function (provider) { return reducerProvider.addStateProvider(provider); });
        }
    }
    /**
     * @template S
     * @param {?=} config
     * @return {?}
     */
    ReduxModule.forChild = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxModule,
            providers: [
                { provide: ReduxStateDefinitionToken, useValue: config.state || null, multi: true },
            ],
        };
    };
    /**
     * @template S
     * @param {?=} config
     * @return {?}
     */
    ReduxModule.forRoot = function (config) {
        if (config === void 0) { config = {}; }
        return {
            ngModule: ReduxModule,
            providers: [
                ReduxReducerProvider,
                ReduxRegistry,
                {
                    provide: ReduxStore,
                    useFactory: config.storeFactory || ReduxModule.defaultStoreFactory,
                    deps: [ReduxReducerProvider]
                },
                { provide: ReduxStateDefinitionToken, useValue: config.state || null, multi: true },
            ],
        };
    };
    /**
     * @param {?} reduxReducerProvider
     * @param {?=} devMode
     * @return {?}
     */
    ReduxModule.defaultStoreFactory = function (reduxReducerProvider, devMode) {
        if (devMode === void 0) { devMode = core.isDevMode(); }
        return redux.createStore(reduxReducerProvider.rootReducer, {}, ReduxModule.defaultEnhancerFactory(devMode));
    };
    /**
     * @param {?} devMode
     * @return {?}
     */
    ReduxModule.defaultEnhancerFactory = function (devMode) {
        if (window['__REDUX_DEVTOOLS_EXTENSION__'] && devMode) {
            return window['__REDUX_DEVTOOLS_EXTENSION__']();
        }
        return ReduxModule.noopEnhancer;
    };
    /**
     * @param {?} next
     * @return {?}
     */
    ReduxModule.noopEnhancer = function (next) {
        return next;
    };
    return ReduxModule;
}());
ReduxModule.decorators = [
    { type: core.NgModule, args: [{
                declarations: [
                    ReduxSelectPipe,
                ],
                exports: [
                    ReduxSelectPipe,
                ],
                imports: [
                    common.CommonModule,
                ],
            },] },
];
/** @nocollapse */
ReduxModule.ctorParameters = function () { return [
    { type: core.Injector, },
    { type: ReduxReducerProvider, },
    { type: Array, decorators: [{ type: core.Optional }, { type: core.Inject, args: [ReduxStateDefinitionToken,] },] },
]; };
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var getActionType = reduxDecorators.ReduxActionDispatcher.getType;
var dispatch = reduxDecorators.ReduxActionDispatcher.dispatch;

exports.ReduxActionContext = reduxDecorators.ReduxActionContextDecoratorForClass;
exports.ReduxAction = reduxDecorators.ReduxActionDecoratorForMethod;
exports.ReduxReducer = reduxDecorators.ReduxReducerDecoratorForMethod;
exports.ReduxState = reduxDecorators.ReduxStateDecoratorForClass;
exports.ReduxModule = ReduxModule;
exports.getActionType = getActionType;
exports.dispatch = dispatch;
exports.ReduxSelect = ReduxSelect;
exports.ReduxReducerProvider = ReduxReducerProvider;
exports.ReduxSelectPipe = ReduxSelectPipe;
exports.ReduxSelector = ReduxSelector;
exports.ReduxStateDefinitionToken = ReduxStateDefinitionToken;
exports.ReduxStateProvider = ReduxStateProvider;
exports.ReduxStore = ReduxStore;
exports.ReduxTestingStore = ReduxTestingStore;
exports.ReduxRegistry = ReduxRegistry;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=harmowatch-ngx-redux-core.umd.js.map
